# encoding: utf-8
import math

def cambia( X, Y, va ) :
	c = math.cos( va[4] )
	s = math.sin( va[4] )
	n = len( X )/2
	i = 0
	while i < n :
		j = 2*i
		Y[j] = X[j] - va[0]
		Y[j+1] = X[j+1] - va[1]

		x =  c*Y[j] + s*Y[j+1]
		y = -s*Y[j] + c*Y[j+1]

		Y[j] =  x 
		Y[j+1] = y

		i += 1

def regresa( X, Y, va ) :
	c = math.cos( va[4] )
	s = math.sin( va[4] )
	n = len( X )/2
	i = 0
	while i < n :
		j = 2*i

		Y[j]   = c*X[j] - s*X[j+1] + va[0]
		Y[j+1] = s*X[j] + c*X[j+1] + va[1]

		i += 1

def calcula_puntos_sobre_elipse( Y, S, va ) :
	a = va[2]
	b = va[3]

	n = len( Y )/2
	k = 0
	while k < n:
		j = 2*k
		x = Y[j]
		y = Y[j+1]

		# Inicialización:
		ai_1 = math.sqrt( x*x + y*y )
		if ai_1 < 1e-6 :
			ai_1 = math.pi/2.0

		v = a*a - b*b

		if math.fabs(y) < b and math.fabs(x) <= v/a :
			if math.fabs(y) < 1e-6 :
				ai_1 = math.pi/2.0
			else :
				p = math.fabs(x)/(1.0 + math.fabs(y)/ai_1)
				if x < 0 :
					p = -p
				ai_1 = math.atan2( a*y, b*(x-p) )
		else :
			ai_1 = math.atan2( a*y, b*x )


		imax = 30
		i=1
		while i <= imax :
			c = math.cos(ai_1)
			s = math.sin(ai_1)
			
			v = a*a - b*b
			f = y*b*c - x*a*s + v*s*c
			fp = -y*b*s - x*a*c - v*s*s + v*c*c
		
			ai = ai_1 - f/fp

			if math.fabs(ai-ai_1) < 1e-8 :
				break

			ai_1 = ai

			i += 1

		S[j] = a*math.cos( ai )
		S[j+1] = b*math.sin( ai )

		k += 1

